• 【leetcode】Word Search (middle)


    今天开始,回溯法强化阶段。

    Given a 2D board and a word, find if the word exists in the grid.

    The word can be constructed from letters of sequentially adjacent cell, where "adjacent" cells are those horizontally or vertically neighboring. The same letter cell may not be used more than once.

    For example,
    Given board =

    [
      ["ABCE"],
      ["SFCS"],
      ["ADEE"]
    ]
    

    word = "ABCCED", -> returns true,
    word = "SEE", -> returns true,
    word = "ABCB", -> returns false.

    思路:

    因为已经知道是回溯法,所以就按步骤来就好了

    AC了,但时间挺长的520ms

    class Solution {
    public:
        bool exist(vector<vector<char> > &board, string word) {
            vector<vector<int>> S(word.length());
            vector<int> X(word.length());
            int row = board.size();
            if(row == 0)
                return word.length() == 0;
    
            int col = board[0].size();
            //找第一个字母的位置
            for(int i = 0; i < row; i++)
            {
                for(int j = 0; j < col; j++)
                {
                    if(board[i][j] == word[0])
                        S[0].push_back(i * col + j);
                }
            }
    
            int k = 0;
            //回溯求解
            while(k >= 0)
            {
                while(!S[k].empty())
                {
                    int loc = S[k].back();
                    X[k] = loc;
                    int r = loc / col;
                    int c = loc % col;
                    S[k].pop_back();
                    if(k < word.length() - 1)
                    {
                        k = k + 1;
                        if(r - 1 >= 0 && board[r - 1][c] == word[k]) //上面的
                        {
                            int loctmp = (r - 1) * col + c;
                            if(!isAlreadyExist(X, k, loctmp))
                                S[k].push_back(loctmp);
                        }
                        if(r + 1 < row && board[r + 1][c] == word[k]) //下面的
                        {
                            int loctmp = (r + 1) * col + c;
                            if(!isAlreadyExist(X, k, loctmp))
                                S[k].push_back(loctmp);
                        }
                        if(c - 1 >= 0 && board[r][c - 1] == word[k]) //左边的
                        {
                            int loctmp = r * col + c - 1;
                            if(!isAlreadyExist(X, k, loctmp))
                                S[k].push_back(loctmp);
                        }
                        if(c + 1 < col && board[r][c + 1] == word[k]) //右边的
                        {
                            int loctmp = r * col + c + 1;
                            if(!isAlreadyExist(X, k, loctmp))
                                S[k].push_back(loctmp);
                        }
    
                    }
                    else
                    {
                        return true;
                    }
                }
            k = k - 1;
            }
            return false;
        }
    
        bool isAlreadyExist(vector<int> X, int k, int loc)
        {
            for(int i = 0; i < k; i++)
            {
                if(X[i] == loc)
                    return true;
            }
            return false;
        }
    };

    大神100ms的代码,用的递归,在判断是否已经用过时直接查找表,会快很多。 没有找第一个字母的位置,而是统一看待,代码量会少一点

    class Solution {
    private:
        vector<vector<char> > *board;
        string *word;
        bool **used;
    private:
        bool isInboard(int i, int j)
        {
            if(i < 0)return false;
            if(i >= board->size())return false;
            if(j < 0)return false;
            if(j >= (*board)[i].size())return false;
            return true;
        }
    
        bool DFS(int si, int sj, int n)
        {
            if(n == word->size())return true;
            if(isInboard(si, sj))
            {
                if(!used[si][sj] && (*board)[si][sj] == (*word)[n])
                {
                    used[si][sj] = true;
                    bool ret = false;
                    if(DFS(si+1, sj, n+1))
                        ret = true;
                    else if(DFS(si-1, sj, n+1))
                        ret = true;
                    else if(DFS(si, sj+1, n+1))
                        ret = true;
                    else if(DFS(si, sj-1, n+1))
                        ret = true;
                    used[si][sj] = false;
                    return ret;
                }
            }
            return false;
        }
    
    public:
        bool exist(vector<vector<char> > &board, string word) {
            if(board.size() == 0)return false;
            this->board = &board;
            this->word = &word;
            used = new bool*[board.size()];
            for(int i = 0; i < board.size(); i ++)
            {
                used[i] = new bool[board[i].size()];
                for(int j = 0; j < board[i].size(); j ++)
                    used[i][j] = false;
            }
            for(int i = 0; i < board.size(); i ++)
                for(int j = 0; j < board[i].size(); j ++)
                    if(DFS(i, j, 0))return true;
            return false;
        }
    };
  • 相关阅读:
    第二代:晶体管计算机
    第一代计算机
    Android应用在不同版本间兼容性处理
    eventBus
    realm
    ijkplayer详解AAA
    USB 3.0规范中译本 第3章 USB 3.0体系结构概览
    ES6 学习笔记
    07_通过上下文获取常见目录
    06_登陆案例保存信息完成
  • 原文地址:https://www.cnblogs.com/dplearning/p/4195592.html
Copyright © 2020-2023  润新知